> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# Create Vendor Bill

POST https://api.letsdeel.com/rest/accounts-payable/vendor-bills
Content-Type: application/json

Creates a new vendor bill in accounts payable, associating it with your organization. Attachments can be added to the bill via a subsequent call using the returned id.

 **Token scopes**: `treasury-vendorbill:write`

Reference: https://developer.deel.com/api/reference/endpoints/treasury/create-vendor-bill-v-2026-01-01

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Body (application/json)

This endpoint expects an object.

- `data` (AccountsPayableVendorBillsPostRequestBodyContentApplicationJsonSchemaData, required)

## Response

### 201

Vendor bill created successfully

- `data` (AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaData, required)

## Errors

### 400 Bad Request Error

Bad request - validation error

- `errors` (list of AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaErrorsItems, required)

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 409 Conflict Error

Conflict - duplicate reference

- `errors` (list of AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaErrorsItems, required)

### 500 Internal Server Error

Internal server error

- `errors` (list of AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaErrorsItems, required)

## Types

### AccountsPayableVendorBillsPostRequestBodyContentApplicationJsonSchemaData

- `date` (string, required) — Invoice/bill date
- `amount` (double, required) — Total amount including VAT
- `currency` (string, required) — ISO 4217 currency code
- `due_date` (string, required) — Due date for payment
- `subtotal` (double, required) — Subtotal amount excluding VAT
- `reference` (string, required) — Vendor bill reference
- `vendor_id` (string, required) — Unique identifier for the Vendor
- `line_items` (list of AccountsPayableVendorBillsPostRequestBodyContentApplicationJsonSchemaDataLineItemsItems, required) — Line items for the vendor bill
- `description` (string, required) — General description of the vendor bill
- `external_id` (string, required) — External system identifier (e.g., Brightflag ID)
- `subsidiary_id` (string, required) — Unique identifier for the Deel legal entity/subsidiary

### AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaData

- `id` (string, required) — Unique identifier for the vendor in the treasury system
- `date` (string, required) — Invoice/bill date
- `amount` (double, required) — Total amount including VAT
- `currency` (string, required) — ISO 4217 currency code
- `due_date` (string, required) — Due date for payment
- `subtotal` (double, required) — Subtotal amount excluding VAT
- `is_active` (boolean, required) — Whether the vendor bill is active
- `reference` (string, required) — Vendor bill reference
- `vendor_id` (string, required) — Vendor ID
- `created_at` (string, required) — Creation timestamp
- `line_items` (list of AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaDataLineItemsItems, required) — Line items for the vendor bill
- `updated_at` (string, required) — Last update timestamp
- `description` (string, required) — General description of the vendor bill
- `external_id` (string, required) — External system identifier (e.g., Brightflag ID)
- `exchange_rate` (double, required, nullable) — Exchange rate to USD
- `subsidiary_id` (string, required) — Unique identifier for the Deel legal entity/subsidiary

### AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaErrorsItems

- `code` (string, required) — Machine-readable error code
- `message` (string, required) — Human-readable explanation

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

### AccountsPayableVendorBillsPostRequestBodyContentApplicationJsonSchemaDataLineItemsItems

- `amount` (double, required) — Total amount for this line item
- `quantity` (double, required) — Quantity of items
- `vat_rate` (double, required) — VAT rate percentage
- `unit_price` (double, required) — Price per unit
- `description` (string, required) — Description of the line item
- `vat_code` (string, optional) — VAT Code name
- `vat_amount` (double, optional) — VAT amount for this line item
- `department_id` (string, optional) — Unique Identifier for the Financial department
- `expense_account_id` (string, optional) — Unique Identifier for the Expense account

### AccountsPayableVendorBillsPostResponsesContentApplicationJsonSchemaDataLineItemsItems

- `id` (string, required) — Unique identifier of the line item
- `amount` (double, required) — Total amount for this line item
- `quantity` (double, required) — Quantity of items
- `vat_rate` (double, required) — VAT rate percentage
- `created_at` (string, required) — Creation timestamp
- `unit_price` (double, required) — Price per unit
- `updated_at` (string, required) — Last update timestamp
- `vat_amount` (double, required) — VAT amount for this line item
- `description` (string, required) — Description of the line item
- `vendor_bill_id` (string, required) — Reference to parent vendor bill
- `vat_code` (string, optional, nullable) — VAT code name
- `department_id` (string, optional, nullable) — Unique identifier for the Financial department
- `expense_account_id` (string, optional, nullable) — Unique identifier for the expense account

## Examples

**Request**

```json
{
  "data": {
    "date": "2025-01-15",
    "amount": 1500,
    "currency": "USD",
    "due_date": "2025-02-15",
    "subtotal": 1500,
    "reference": "BF-2025-001",
    "vendor_id": "123",
    "line_items": [
      {
        "amount": 1500,
        "quantity": 10,
        "vat_rate": 0,
        "unit_price": 150,
        "description": "Legal consultation services"
      }
    ],
    "description": "Legal services for Q1 2025",
    "external_id": "brightflag-invoice-12345",
    "subsidiary_id": "456"
  }
}
```

**Response**

```json
{
  "data": {
    "id": "9b9fc43a-a90c-4615-ac50-baf1e314b53e",
    "date": "2025-01-15",
    "amount": 1500,
    "currency": "USD",
    "due_date": "2025-02-15",
    "subtotal": 1500,
    "is_active": true,
    "reference": "BF-2025-001",
    "vendor_id": "123",
    "created_at": "2025-01-15T10:30:00Z",
    "line_items": [
      {
        "id": "9dd4c31a-7613-477e-bf67-3b56ec8879d9",
        "amount": 1500,
        "quantity": 10,
        "vat_rate": 0,
        "created_at": "2025-01-15T10:30:00Z",
        "unit_price": 150,
        "updated_at": "2025-01-15T10:30:00Z",
        "vat_amount": 0,
        "description": "Legal consultation services",
        "vendor_bill_id": "9b9fc43a-a90c-4615-ac50-baf1e314b53e",
        "vat_code": "S-GB",
        "department_id": "99",
        "expense_account_id": "250"
      }
    ],
    "updated_at": "2025-01-15T10:30:00Z",
    "description": "Legal services for Q1 2025",
    "external_id": "brightflag-invoice-12345",
    "exchange_rate": 1,
    "subsidiary_id": "456"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/accounts-payable/vendor-bills"

payload = { "data": {
        "date": "2025-01-15",
        "amount": 1500,
        "currency": "USD",
        "due_date": "2025-02-15",
        "subtotal": 1500,
        "reference": "BF-2025-001",
        "vendor_id": "123",
        "line_items": [
            {
                "amount": 1500,
                "quantity": 10,
                "vat_rate": 0,
                "unit_price": 150,
                "description": "Legal consultation services"
            }
        ],
        "description": "Legal services for Q1 2025",
        "external_id": "brightflag-invoice-12345",
        "subsidiary_id": "456"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/accounts-payable/vendor-bills';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"date":"2025-01-15","amount":1500,"currency":"USD","due_date":"2025-02-15","subtotal":1500,"reference":"BF-2025-001","vendor_id":"123","line_items":[{"amount":1500,"quantity":10,"vat_rate":0,"unit_price":150,"description":"Legal consultation services"}],"description":"Legal services for Q1 2025","external_id":"brightflag-invoice-12345","subsidiary_id":"456"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/accounts-payable/vendor-bills"

	payload := strings.NewReader("{\n  \"data\": {\n    \"date\": \"2025-01-15\",\n    \"amount\": 1500,\n    \"currency\": \"USD\",\n    \"due_date\": \"2025-02-15\",\n    \"subtotal\": 1500,\n    \"reference\": \"BF-2025-001\",\n    \"vendor_id\": \"123\",\n    \"line_items\": [\n      {\n        \"amount\": 1500,\n        \"quantity\": 10,\n        \"vat_rate\": 0,\n        \"unit_price\": 150,\n        \"description\": \"Legal consultation services\"\n      }\n    ],\n    \"description\": \"Legal services for Q1 2025\",\n    \"external_id\": \"brightflag-invoice-12345\",\n    \"subsidiary_id\": \"456\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/accounts-payable/vendor-bills")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"date\": \"2025-01-15\",\n    \"amount\": 1500,\n    \"currency\": \"USD\",\n    \"due_date\": \"2025-02-15\",\n    \"subtotal\": 1500,\n    \"reference\": \"BF-2025-001\",\n    \"vendor_id\": \"123\",\n    \"line_items\": [\n      {\n        \"amount\": 1500,\n        \"quantity\": 10,\n        \"vat_rate\": 0,\n        \"unit_price\": 150,\n        \"description\": \"Legal consultation services\"\n      }\n    ],\n    \"description\": \"Legal services for Q1 2025\",\n    \"external_id\": \"brightflag-invoice-12345\",\n    \"subsidiary_id\": \"456\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/accounts-payable/vendor-bills")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"date\": \"2025-01-15\",\n    \"amount\": 1500,\n    \"currency\": \"USD\",\n    \"due_date\": \"2025-02-15\",\n    \"subtotal\": 1500,\n    \"reference\": \"BF-2025-001\",\n    \"vendor_id\": \"123\",\n    \"line_items\": [\n      {\n        \"amount\": 1500,\n        \"quantity\": 10,\n        \"vat_rate\": 0,\n        \"unit_price\": 150,\n        \"description\": \"Legal consultation services\"\n      }\n    ],\n    \"description\": \"Legal services for Q1 2025\",\n    \"external_id\": \"brightflag-invoice-12345\",\n    \"subsidiary_id\": \"456\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/accounts-payable/vendor-bills', [
  'body' => '{
  "data": {
    "date": "2025-01-15",
    "amount": 1500,
    "currency": "USD",
    "due_date": "2025-02-15",
    "subtotal": 1500,
    "reference": "BF-2025-001",
    "vendor_id": "123",
    "line_items": [
      {
        "amount": 1500,
        "quantity": 10,
        "vat_rate": 0,
        "unit_price": 150,
        "description": "Legal consultation services"
      }
    ],
    "description": "Legal services for Q1 2025",
    "external_id": "brightflag-invoice-12345",
    "subsidiary_id": "456"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/accounts-payable/vendor-bills");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"date\": \"2025-01-15\",\n    \"amount\": 1500,\n    \"currency\": \"USD\",\n    \"due_date\": \"2025-02-15\",\n    \"subtotal\": 1500,\n    \"reference\": \"BF-2025-001\",\n    \"vendor_id\": \"123\",\n    \"line_items\": [\n      {\n        \"amount\": 1500,\n        \"quantity\": 10,\n        \"vat_rate\": 0,\n        \"unit_price\": 150,\n        \"description\": \"Legal consultation services\"\n      }\n    ],\n    \"description\": \"Legal services for Q1 2025\",\n    \"external_id\": \"brightflag-invoice-12345\",\n    \"subsidiary_id\": \"456\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "date": "2025-01-15",
    "amount": 1500,
    "currency": "USD",
    "due_date": "2025-02-15",
    "subtotal": 1500,
    "reference": "BF-2025-001",
    "vendor_id": "123",
    "line_items": [
      [
        "amount": 1500,
        "quantity": 10,
        "vat_rate": 0,
        "unit_price": 150,
        "description": "Legal consultation services"
      ]
    ],
    "description": "Legal services for Q1 2025",
    "external_id": "brightflag-invoice-12345",
    "subsidiary_id": "456"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/accounts-payable/vendor-bills")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```